library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.CONSTANTS.all;
entity generic_reg is
	generic (n: integer := 8);
	port(
		clk : in std_logic;
		rst : in std_logic;
		clr: in std_logic;
		ld: in std_logic;
		data_in : in std_logic_vector(n-1 downto 0);
		data_out : out std_logic_vector(n - 1 downto 0)
	);
end entity generic_reg;

architecture RTL of generic_reg is

signal currentValue : std_logic_vector(n - 1 downto 0);

begin

	reg_p : process(clk, rst)
	begin
		if (rst = '1') then
			currentValue <= (others => '0');
		elsif (clk'event and clk = '1') then
			if (clr = '1') then
				currentValue <= (others => '0');
			elsif (ld = '1') then
				currentValue <= data_in;
			end if;
		end if;
	end process reg_p;

	data_out <= currentValue;
end architecture RTL;
